;	   3.
;    . -   , 
;   .  -  16 .
;
;  : 1.   = 10.000 
; 		     2.        .
;                            .
;
; 31/5/95  
;

	 .mmregs
	 .ds 	0f00h
;
;
TA 	.word 18
RA 	.word 18
;
TB 	.word 18	;   = 15.432
RB 	.word 18
AIC_CTR .word 08h	; xmit  RCV 
TIME 	.word 0d60h	;  
TIMER 	.word 00000h
DIGIT	.word 00000h
; ,    
c1 	.word 25736	;(6488h) 1.570796327
c3 	.word -10583	;(d6a9h) -0.6459640968
c5 	.word 1306	;(051Ah) 0.07969260
c7 	.word -77	;(ffb4h) -0.004681666
c9 	.word 3		;(0003h) 0.00016
sinput 	.word 0
soutput .word 0
temp 	.word 0		;    
x2 	.word 0		;  x2 (  x  )
x	.word 0		;  x
St1val  .word 07fdh
;Sintime .word 1096h	; ,     1k.
tonesum .word 0		;     .
tonlen  .word 0		;    ( ).
valbase .word 0		;    .
valtreb .word 0		;    .
ar2str 	.word 0		;   Ar1
	.word 0		; 1     .


tonetab
	.include 	minuet.txt
toneend .word 0
coefftab
	.include 	demo3_16.flt;   -
firtab  
	.include 	demo3_16.flt;       X(n-a).
firend
; ***************************************************************
;  ISR  						*
; ***************************************************************
	 .ps 	080ah		;
rint: 	B 	RECEIVE		; 0A;     RINT.
xint: 	B 	TRANSMIT	; 0C;     XINT.

;
; *****************************************************************
; TMS32C05X  					 *
;								 *
; *****************************************************************
	 .ps 	0a00h
	 .entry
	 SETC 	INTM		;  
	 LDP  	#0		;     
	 OPL  	#0834h,PMST	;     PMST
	 LACC 	#0
	 SAMM 	CWSR		;     
	 SAMM 	PDWSR		;   
;
	 CLRC 	OVM		; OVM = 0    
	 SPM 	0		; PM = 0       
	ldp 	#0
	splk    #03,INDX	;     3
	splk 	#02,IMR		;  tx int( ).
	ldp 	#c1
	lst 	#1,st1val	;    ,    
	zap			;  
	sacl 	valbase
	lar 	ar2,#tonetab	;     .
	nop
	nop
	mar	*,ar2		;  Ar4 
	lacc 	*+		;    .
	nop
	nop
	sar 	ar2,ar2str	;  .
	sacl 	tonlen		;   
;  AIC   PA2 ( > 52)  DSK

	ldp 	#0
	 SPLK 	 #022h,IMR	;    XINT   TX  RX
	 CALL 	 AICINIT	;  AIC   
	 CLRC INTM		;  

forever  IDLE
	 B 	forever 
	 
; -------    ----------;

;
; --------------------------   ISR --------------------------
;  
RECEIVER:        
		 RETE
; --------------------------  ISR --------------------------
;
TRANSMIT:
;      AR1      .
;      AR1 -  AR .
	 mar 	*,ar2		;  ar2 
	 ldp 	#tonlen
	 lacl   tonesum
	 samm 	DXR		;   .
	 lacl 	tonlen		; .      .
	 lar 	ar2,ar2str
	 sub 	#1		;  .
	 bcnd 	lenok,NEQ       
		adrk 	#2	;    
		lacl 	*+	;        .
		bcnd 	lenok,NEQ	;  ,     .
			lar 	ar2,#tonetab;     
			lacl 	*+	;   
lenok 	sacl 	tonlen		;    .
;     .
	lacl 	valtreb		;     .
	add 	*+		;      ,    .
	sacl 	valtreb		;    
	sacl 	sinput          
	call 	sin		;   .
	lacc 	soutput,0	;  ,   .
	sfr			;   (  2).
	sacl 	tonesum		; ,    .
;     .
       lacl 	valbase		;     .
       add 	*-		;      ,    .
       sacl 	valbase		;    
       sacl 	sinput          
       call 	sin		;   .
       lacc 	soutput		;  ,   .
       sfr			;   (  2).
;        .      
	add 	tonesum		
	 call 	fir
	 sar 	ar2,ar2str
	 rete
; ----------------------------  ISR ------------------------
;
; : 		-
;        63 .
;
;    a.
;
fir:
	ldp 	#firtab
	sacl 	firtab,0	;       
	lar 	ar1,#firend	;   -   .
	mar 	*,ar1		;  AR1 .
	zap			;  accum
	rpt	#161 
	macd 	coefftab,*-	; ,    .
	ldp 	#tonesum
	and 	#0fffch,16	;  2   16  ,  .
	sach 	tonesum		;  .
	ret







;
; *****************************************************************
; :   'C50   *
;            TLC320C40'S (AIC) TA, RA, TB, RB  		   *
;                 				   *
; *****************************************************************
;
AICINIT: SPLK 	#20h,TCR	;       
	 SPLK 	#01h,PRD	; (10 )   TLC32040
	 MAR	*,AR0
	 LACC 	#0008h		;     
	 SACL 	SPC		; FSX  
	 LACC	#00c8h		; 16  
	 SACL 	SPC
	 LACC 	#080h		;   AIC (  )
	 SACH 	DXR
	 SACL 	GREG
	 LAR 	AR0,#0FFFFh
	 RPT	#10000		;      10000 
	 LACC 	*,0,AR0		; (.5ms  50ns)
	 SACH 	GREG
	; ------------------------
	 LDP	#TA		;
	 SETC 	SXM		;
	 LACC 	TA,9		;  TA  RA 
	 ADD	RA,2		;
	 CALL 	AIC_2ND		;
	; ------------------------
	 LDP	#TB
	 LACC 	TB,9		;  TB   RB 
	 ADD	RB,2		;
	 ADD	#02h		;
	 CALL	AIC_2ND		;
	; ------------------------
	 LDP	*AIC_CTR
	 LACC 	AIC_CTR, 2	;     TLC32040
	 ADD	#03h		;
	 CALL	AIC_2ND		;
	 RET			;

AIC_2ND:
	 LDP	#0		;    - 0 (MM regs)
	 SACH 	DXR		;   . ACCHi 00
	 CLRC 	INTM		;  
	 IDLE			;   
	 ADD	#6h,15		; 0000 0000 0000 0011 XXXX XXXX XXXX XXXX b
	 SACH 	DXR		;   
	 IDLE			;  
	 SACL 	DXR		;   
	 IDLE			;  
	 LACL 	#0		;  ACCLO
	 SACL 	DXR		;  
	 IDLE			;  
	 SETC 	INTM
	 RET			;


	 .INCLUDE SINSUB.ASM



	 .end

