;	   5.
;          .
;
;  : 1.   = 10.000 MHz
;                    2.        .
;                            .
;
;       Mike Reddish 18/5/95
;

	 .mmregs
	 .ds     0f00h
;
;
TA       .word    18
RA       .word    18
;
TB       .word    18       ;   = 15.432
RB       .word    18
AIC_CTR  .word    08h      ; xmit & RCV 
TIME     .word    0d60h           ;  
TIMER    .word    00000h
DIGIT    .word    00000h
;ramp     .word    0000h
; ,    
c1      .word   25736   ;(6488h) 1.570796327
c3      .word   -10583  ;(d6a9h) -0.6459640968
c5      .word   1306    ;(051Ah) 0.07969260
c7      .word   -77     ;(ffb4h) -0.004681666
c9      .word   3       ;(0003h) 0.00016
sinput  .word   0
soutput .word   0
temp    .word   0       ;  
x2      .word   0       ;  x2 (  x  )
x       .word   0       ;  x
st1val  .word   07fdh
sintime .word   1000	; ,    235.


;***************************************************************
;    ISR                                       *
;***************************************************************
	 .ps     080ah         ;
rint:    B       RECEIVE       ;0A;     RINT.
xint:    B       TRANSMIT      ;0C;     INT.

;
;*****************************************************************
;  TMS32C05X                                        *
;                                                                *
;*****************************************************************
	 .ps     0a00h
	 .entry
	 SETC    INTM             ;  
	 LDP     #0               ;    
	 OPL     #0834h,PMST      ;     PMST
;         LACC    #0
	 SAMM    CWSR             ;     
	 SAMM    PDWSR            ;     
;         LACC    #THREE           ;     THREE
;  AIC,   PA2 ( >52)  DSK

	 SPLK    #022h,IMR        ;  XINT   TX & RX
	 CALL    AICINIT          ;  AIC   
;
	 CLRC    OVM              ;     OVM = 0 
	 SPM     0                ;    PM = 0    
	 LACC    #0
	 CLRC    INTM             ;  
	ldp     #c1
	lst     #1,st1val       ;    ,    
forever  IDLE
	 B       forever
	 
;-------    ----------;

;
;--------------------------   ISR  --------------------------
;  
RECEIVE:        
		RETE
;--------------------------   ISR  --------------------------
;
TRANSMIT:
	 
	 LDP     #sinput            ;      sinput.
	 LACL    sinput             ;   
	 ADD     sintime,0            ;   1000h (16   )
	 SACL    sinput
	 CALL    sin            ;   
	 LACL    soutput
	 AND     #0FFFCh,0        ;  0 & 1     AIC
	 SAMM    DXR              ;    AIC   
;        SACL    ramp             ;   .
	 RETE


;----------------------------  ISR ------------------------

;
;*****************************************************************
;  :    'C50 *
;                 TLC320C40 (AIC) TA,RA,TB,RB               *
;                                              *
;*****************************************************************
;
AICINIT: SPLK    #20h,TCR           ;  10   Tout
	 SPLK    #01h,PRD           ;    AIC
	 MAR     *,AR0
	 LACC    #0008h             ;     
	 SACL    SPC                ; FSX  
	 LACC    #00c8h             ; 16  
	 SACL    SPC
	 LACC    #080h            ;   AIC,  	 
	 SACH    DXR
	 SACL    GREG
	 LAR     AR0,#0FFFFh
	 RPT     #10000           ;      10000 
	 LACC    *,0,AR0          ; (.5ms  50ns)
	 SACH    GREG
	 ;------------------------
	 LDP     #TA              ;
	 SETC    SXM              ;
	 LACC    TA,9             ;  TA and RA 
	 ADD     RA,2             ;
	 CALL    AIC_2ND          ;
	 ;------------------------
	 LDP     #TB
	 LACC    TB,9             ;  TB and RB 
	 ADD     RB,2             ;
	 ADD     #02h             ;
	 CALL    AIC_2ND          ;
	 ;------------------------
	 LDP     #AIC_CTR
	 LACC    AIC_CTR,2        ;   
	 ADD     #03h             ;
	 CALL    AIC_2ND          ;
	 RET                      ;

AIC_2ND:
	 LDP     #0               ;    - 0  (MM regs)
	 SACH    DXR              ;    ACChi 00           
	 CLRC    INTM             ;  
	 IDLE                     ;  
	 ADD     #6h,15           ; 0000 0000 0000 0011 XXXX XXXX XXXX XXXX b
	 SACH    DXR              ;   
	 IDLE                     ;  
	 SACL    DXR              ;   
	 IDLE                     ;  
	 LACL    #0               ;    ACClo
	 SACL    DXR              ;  
	 IDLE                     ;  
	 SETC    INTM
	 RET                      ;


	.INCLUDE SINSUB.ASM



	.end

