;	   3
;	  
	 .mmregs
	 .ds     0f00h
;
;
TA      .word 16 ;
RA      .word 16 ;
TAp     .word 1 ;  
RAp     .word 1 ; " "
TB      .word 31; 
RB      .word 31; 
AIC_CTR .word 08h ;
Output  .word 0
Temp    .word 0;

 .include filter.flt

;***************************************************************
;    ISR                                       *
;***************************************************************
	 .ps     080ah         ;
rint:    B       RECEIVE       ;0A;     RINT.
xint:    B       TRANSMIT      ;0C;     XINT.

;
;*****************************************************************
; TMS32C05X                                         *
;                                                                *
;*****************************************************************
	 .ps     0a00h
	 .entry
	 SETC    INTM             ;  
	 LDP     #0               ;    
	 OPL     #0834h,PMST      ;     PMST
	 LACC    #0
	 SAMM    CWSR             ;    
	 SAMM    PDWSR            ;    
	 SETC    SXM
	 SPLK    #022h,IMR        ;    XINT   TX & RX
	 CALL    AICINIT          ;  AIC   
	 SPLK    #12h,IMR ;     
	 CLRC    OVM
	 SPM 0
	 CLRC    INTM             ;  

forever  IDLE
	 B       forever

;-------    ----------;


;--------------------------   ISR  --------------------------
RECEIVE:
    LDP #XN
    CLRC INTM
    LAMM DRR ;   ACC
    SACL XN
; start FIR
    LAR  ar0,#XNLAST     ;   -   .
    ZAP
    MAR  *,ar0           ;  AR1 .
    RPT  #taps-1
    MACD #coefftab,*-     ; ,    .
    APAC
    SACH Output,1
    LACC Output
    SFL
    AND  #0fffch ;   2   16- ,  .
    SAMM DXR
    RETE
;--------------------------   ISR  --------------------------
;
TRANSMIT:
    RETE

******************************************************************
* :    TLC32040   *
*                                                 *
******************************************************************                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               *  AIC

AICINIT:
	SPLK #01h,PRD
	SPLK #20h,TCR 	;    10 
	MAR *,AR0
	LACC #0008h 	;     
	SACL SPC 	; FSX  
	LACC #00c8h 	; 16  
	SACL SPC
	LACC #080h 	;   AIC (  )
	SACH DXR
	SACL GREG
	LAR AR0,#0FFFFh
	RPT #10000 	;      10000 
	LACC *,0,AR0 	; (.5ms  50ns)
	SACH GREG
	LDP #TA 	;
	SETC SXM 	;
	LACC TA,9 	;  TA and RA 
	ADD RA,2 	;
	CALL AIC_2ND 	;
	;------------------------
	LDP #TB
	LACC TB,9 	;  TB and RB 
	ADD RB,2 	;
	ADD #02h 	;
	CALL AIC_2ND 	;
	;------------------------
	LDP #AIC_CTR
	LACC AIC_CTR,2  ;   
	ADD #03h 	;
	;LACC #11100000b
	CALL AIC_2ND 	;
	RET 		;

AIC_2ND:
	LDP #0
	SACH DXR 	;
	CLRC INTM
	IDLE
	ADD #6h,15 	; 0000 0000 0000 0011 XXXX XXXX XXXX XXXX b
	SACH DXR 	;
	IDLE
	SACL DXR 	;
	IDLE
	LACL #0 	;
	SACL DXR 	;  
	IDLE
	SETC INTM
	RET 		;


	.end

                                                                                                                                                             