typedef unsigned int   UINT;
typedef unsigned char  UCHAR;
typedef unsigned char* BYTE;
typedef          char* STRING;
typedef unsigned long  ULONG;

# include <alloc.h>
# include <conio.h>
# include <ctype.h>
# include <direct.h>
# include <dos.h>
# include <fcntl.h>
# include <io.h>
# include <malloc.h>
# include <math.h>
# include <graphics.h>
# include <setjmp.h>
# include <stdio.h>
# include <stdarg.h>
# include <stdlib.h>
# include <string.h>
# include <float.h>
# include <time.h>
#include  <bios.h>

# define  pgm         "Program"
# define  dta         "Data"
# define  TMS         "TMS320C50"


# define KB_ESC    0x001b    // scan code: 0x11b ?
# define THR      0    // Transmitter holding register
# define DHR      0    // Receiver data       register
# define BRDL     0    // Baud rate devisor, low byte
# define BRDH     1    // Baud rate devisor, high byte
# define LCR      3    // Line control register
# define MSR      4    // Modem status register
# define LSR      5    // Line status register
# define DATA_READY    1  //  defined in the LCR register
# define DATA_OVERRUN  2  //  defined in the LCR register
# define TRUE     1
# define FALSE    0
# define XMT_BUF_EMPTY 0x20
# define DD       0    // Upload data from DSK -> PC
# define DP       1    // Upload prog from DSK -> PC
# define LD       2    // Download data from PC -> DSK
# define LP       3    // Download prog from PC -> DSK
# define XG       5    // Execute the program
// do also the max for float, double, etc... ????
#define MAXLINE  100
#define yes 1
#define no 0
enum INITMONITOR {GOOD,TESTERROR,NOESCAPE,NORESPONSE};
struct PARAMETER {
	   UINT  PGM_CNT;
	   UINT  EntryPoint;
	   char INVERSE;
	   UINT  com; // comport
	   ULONG speed; // Baudrate
	 };
//-----------------------------------------------------------------------
void        BaudRateDetect(void);
UCHAR       Bcrcv(int);
void        check_key(void);
void        ExePgm(void);         // eXcecute Go, Address, Single step
UINT        GetDskAdd(STRING pbuf);
UINT        GetDskData(STRING pbuf,UINT data[]);
void        InitializeMonitor(void);
void        init_graphics(void);
UINT        InitMonitor(void);
void        InitPort(void);
double      LoadDsk(void);
void        reset50(void);
void        sendbyte(UINT);
UINT        sendword(UINT);
void        setup_vals(void);
void        WaitFor(UINT);

